--[[=============================================================================
    Copyright 2016 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_specific_commands = "2016.01.08"
end

--[[=============================================================================
    ExecuteCommand Code

    Define any functions for device specific commands (EX_CMD.<command>)
    received from ExecuteCommand that need to be handled by the driver.
===============================================================================]]
--function EX_CMD.NEW_COMMAND(tParams)
--	LogTrace("EX_CMD.NEW_COMMAND")
--	LogTrace(tParams)
--end

function EX_CMD.ControlOutlet(tParams)
    LogTrace("EX_CMD.ControlOutlet ()")
    LogTrace(tParams)
    
    local outlet = tostring(tParams["Outlet"])
    local action = ""
    local command = ""

    
    if(tParams["Control Action"] == "OFF") then 
	   action = " 0"
	   command = "pset "
    elseif(tParams["Control Action"] == "ON") then 
	   action = " 1"
	   command = "pset "
    elseif(tParams["Control Action"] == "CYCLE") then 
	   action = ""
	   command = "prb "
    end
    command1 = (command .. outlet .. action)
    PackAndQueueCommand("ControlOutlet",command1)
end

function EX_CMD.RebootWholePDU(tParams)
    LogTrace("EX_CMD.RebootWholePDU ()")
    local command = "reboot"
    PackAndQueueCommand("Reboot", command)
end

function EX_CMD.TurnOnAllOutlets(tParams)
    LogTrace("EX_CMD.TurnOnAllOutlets ()")
    local command = "ps 1"
    PackAndQueueCommand("AllOutletsOn", command)
end

function EX_CMD.TurnOffAllOutlets(tParams)
    LogTrace("EX_CMD.TurnOffAllOutlets ()")
    local command = "ps 0"
    PackAndQueueCommand("AllOutletsOff", command)
end