--[[=============================================================================
    Properties Code

    Copyright 2016 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.properties = "2016.01.08"
end



function ON_PROPERTY_CHANGED.NetworkKeepAliveIntervalSeconds(propertyValue)
	gNetworkKeepAliveInterval = tonumber(propertyValue)

end

function ON_PROPERTY_CHANGED.Username(propertyValue)
	gLoginAttempts = 0
end

function ON_PROPERTY_CHANGED.Password(propertyValue)
	gLoginAttempts = 0
end

function ON_PROPERTY_CHANGED.DeviceStatusPollingIntervalSeconds(propertyValue)
	gPollingTimerInterval = tonumber(propertyValue)
	
	--destroy current and then create new instance of polling timer...
	if (gCon ~= nil) then
	    if (gCon._PollingTimer ~= nil) then 
		    gCon._PollingTimer:KillTimer()
		    gCon._PollingTimer = nil
	    end
	    
	    gCon:InitPolling(tonumber(gPollingTimerInterval), "SECONDS", gCon)
	    gCon:StartPolling(tonumber(gPollingTimerInterval), "SECONDS")
	end
	
end

--[[=============================================================================
    UpdateProperty(propertyName, propertyValue)
  
    Description:
    Sets the value of the given property in the driver
  
    Parameters:
    propertyName(string)  - The name of the property to change
    propertyValue(string) - The value of the property being changed
  
    Returns:
    None
===============================================================================]]
function UpdateProperty(propertyName, propertyValue)

	if (Properties[propertyName] ~= nil) then
		C4:UpdateProperty(propertyName, propertyValue)
	end
end

