--[[=============================================================================
    Commands received from the generic proxy (ReceivedFromProxy)

    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.proxy_commands = "2015.10.21"
end

--[[=============================================================================
    GET_STATE()

    Description
    Called whenever the proxy handles the GET_STATE command. This typically
    happens whenever a UI requests the current state.

    Parameters
    None

    Returns
    Nothing
===============================================================================]]
function GET_STATE()
	--TODO: Implement code to handle whenever someone requests the current state.
	--      i.e. You may want to increase the interval for polling the device.

end

--[[=============================================================================
    SET_LEVEL(level)

    Description
    Creates a packet/command to send to the device

    Parameters
    level   - Set the level of the device

    Returns
    Nothing
===============================================================================]]
function SET_LEVEL(level)
	local command = ""

	if (level ~= nil) then
		-- TODO: Implement the packet/command to send to the device

		LogTrace("command = " .. command)
		if (string.len(command) > 0) then
			gCon:SendCommand(command)
		end
	end
end

function PRX_CMD.OPEN(idBinding, tParams)
    local command = "pset "
    local port = (idBinding) -100
    local command = ("pset " .. port .. " 0")
    PackAndQueuePriority1Command("PSET", command)
end

function PRX_CMD.TOGGLE(idBinding, tParams)
    local port = (idBinding) -100
    local state = ""
    
    if RelayToggleState [idBinding] == 1 then
	  state = 0
    else
	  state = 1
    end
    
    local command = ("pset " .. port .. " " ..state)
    PackAndQueuePriority1Command("PSET", command)
end

function PRX_CMD.CLOSE(idBinding, tParams)
    local port = (idBinding) -100
    local command = ("pset " .. port .. " 1")
    PackAndQueuePriority1Command("PSET", command)
end


