--[[=============================================================================
    Initialization Functions

    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]
require "generic.generic_proxy_class"
require "generic.generic_proxy_commands"
require "generic.generic_proxy_notifies"

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.proxy_init = "2015.10.21"
end

function ON_DRIVER_EARLY_INIT.proxy_init()
	-- declare and initialize global variables

end

function ON_DRIVER_INIT.proxy_init()
    -- instantiate the generic proxy class
    local maxLevel = 100
    gGenericProxy = GenericProxy:new(DEFAULT_PROXY_BINDINGID, maxLevel)
	
    CMDS = {
	   ['Show_Userlist']			= 'ul',
	   ['Show_Version']    			= 'ver',
	   ['Show_Date']    			= 'date',
	   ['Show_Time']    			= 'time',
	   ['Read_Current_A']    		= 'cura',
	   ['Read_Current_B']    		= 'curb',
	   ['Show_Serial_Number']    		= 'ssn',
	   ['Display_Power_Outlet_Status'] = 'pshow',
	   ['Set_Power_Outlet']  		= 'pset ', --Sets power outlet #n to v(value 1-on, 0-off)
	   ['All_Outlet_On']    			= 'ps 1',
	   ['All_Outlet_Off']    		= 'ps 0',
	   ['Reboot_Outlet']    			= 'prb ',
	   ['Show_Mac']    				= 'mac',
	   ['Reboot']    				= 'reboot',
	   ['Repeat_Last_Command']   		= '!',
	   ['Read_Temperature_Sensor']    	= 'temp',
	   ['Read_Humidity_Sensor']    	= 'rh',
    }

end

function ON_DRIVER_LATEINIT.proxy_init()

end

function initialize()
    LogTrace("initialize()")
    PollProperties(true)
end